URLSCAN(1)

NAME
urlscan - browse the URLs in an email message from a terminal

SYNOPSIS
urlscan [options] < message urlscan [options] message

DESCRIPTION
urlscan accepts a single email message on standard input, then displays a terminal-based list of the URLs in the given message. Selecting a URL uses the Python webbrowser module to determine which browser to open. The BROWSER environment variable will be used if it is set. urlscan is primarily intended to be used with the mutt (1) mailreader, but it should work well with any terminal-based mail program. urlscan is similar to urlview(1), but has the following additional features: 1. Support for more message encodings, such as quoted-printable and base64. 2. Extraction and display of the context surrounding each URL. Toggle context view on/off with c. 3. Copy current URL to primary selection with P or to clipboard with C. 4. URLs are shortened by default to fit on one line. Toggle one or all shortened URLs with s or S. 5. Incremental case-insensitive search using /. Footer shows current search term. / again resets search. 6. Cycle through all available palettes (color and black & white available by default) using p. Running urlscan -g will generate a ~/.config/urlscan/config.json file for editing or adding additional pallettes and keybindings. See http://urwid.org/manual/displayattributes.html#display-attributes for color options and allowed values. 7. u will unescape the highlighted URL if necessary. 8. Run a command with the selected URL as the argument or pipe the selected URL to a command using the --run and --pipe arguments. 9. Use l to cycle through whether URLs are opened using the Python webbrowser module (default), xdg-open (if installed) or a function passed on the command line with --run. The --run function will respect the value of --pipe. 10. F1 shows the help menu.

OPTIONS

-g, --genconf
    Generate ~/.config/urlscan/config.json with default options.

-c, --compact
    Display a simple list of the extracted URLs, instead of showing the context of each URL. Also toggle with `c` from within the viewer.

-H, --nohelp
    Start with header menu hidden.

-d, --dedupe
    Remove duplicated URLs from the list of URLs.

-n, --no-browser
    Disables the selection interface and print the links to standard output. Useful for scripting (implies --compact).

-r, --run <expression>
    Execute <expression> in place of opening URL with a browser. Use {} in <expression> to substitute in the URL. Examples:
        $ urlscan --run 'echo {} | xclip -i' file.txt
        $ urlscan --run 'tmux set buffer {}'

-p, --pipe
    Pipe the selected URL to the command specified by `--run`. This is preferred when the command supports it, as it is more secure and tolerant of special characters in the URL. Example:
        $ urlscan --run 'xclip -i' --pipe file.txt

MUTT INTEGRATION
To integrate urlscan with mutt, include the following two commands in ~/.muttrc: macro index,pager \cb "<pipe-message> urlscan<Enter>" "call urlscan to extract URLs out of a message" macro attach,compose \cb "<pipe-entry> urlscan<Enter>" "call urlscan to extract URLs out of a message" Once these lines are in your mutt configuration file, pressing Control-b will allow you to browse and open the URLs in the currently selected message. Alternately, you can pipe a message into urlscan using the '|' operator. This can be useful for applying a different flag (such as the '-d' or '-c' options).

KEYBINDINGS
Run urlscan -g to generate ~/.config/urlscan/config.json. All of the keys will be listed. You can either leave in place or delete any that will not be altered. To unset a binding, set it equal to "". For example: "P": "" The follow actions are supported:

all_escape -- toggle unescape all URLs (Default: u)

all_shorten -- toggle shorten all URLs (Default: S)

bottom -- move cursor to last item (Default: G)

clear_screen -- redraw screen (Default: Ctrl-l)

clipboard -- copy highlighted URL to clipboard using xsel/xclip (Default: C)

clipboard_pri -- copy highlighted URL to primary selection using xsel/xclip (Default: P)

context -- show/hide context (Default: c)

down -- cursor down (Default: j)

help_menu -- show/hide help menu (Default: F1)

link_handler -- cycle link handling (webbrowser, xdg-open or custom) (Default: l)

open_url -- open selected URL (Default: space or enter)

palette -- cycle through palettes (Default: p)

quit -- quit (Default: q or Q)

shorten -- toggle shorten highlighted URL (Default: s)

top -- move to first list item (Default: g)

up -- cursor up (Default: k)

FILES
$HOME/.config/urlscan/config.json Only required if additional or modified palettes are desired.

SEE ALSO
/usr/share/doc/urlscan/README, urlview(1), mutt(1)

AUTHOR
This manual page was written by Daniel Burrows <dburrows@debian.org> and Scott Hansen <firecat4153@gmail.com>